Magellan Linux

Diff of /tags/grubby-8_40_20170706/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1332 by niro, Fri Jun 3 20:32:19 2011 UTC revision 2971 by niro, Thu Jun 30 10:06:57 2016 UTC
# Line 25  Line 25 
25  # along with this program.  If not, see <http://www.gnu.org/licenses/>.  # along with this program.  If not, see <http://www.gnu.org/licenses/>.
26  #  #
27    
28    read_os_release()
29    {
30     local NAME
31     local ID
32     local Version
33     local Version_ID
34     local PRETTY_NAME
35     local ANSI_COLOR
36     local CPE_NAME
37    
38     if [[ -f /etc/os-release ]]
39     then
40     source /etc/os-release
41    
42     case $1 in
43     name) echo "${NAME}" ;;
44     id) echo "${ID}" ;;
45     version) echo "${Version}" ;;
46     version_id) echo "${Version_ID}" ;;
47     pretty_name) echo "${PRETTY_NAME}" ;;
48     ansi_color) echo "${ANSI_COLOR}" ;;
49     cpe_name) echo "${CPE_NAME}" ;;
50     esac
51     fi
52    }
53    
54  PATH=/sbin:/bin:$PATH  PATH=/sbin:/bin:$PATH
55    
56  lilo=/sbin/lilo  lilo=/sbin/lilo
# Line 40  else Line 66  else
66  fi  fi
67    
68  [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby  [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69    [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70    
71    cfgGrub2=""
72    cfgGrub2Efi=""
73  cfgGrub=""  cfgGrub=""
74  cfgLilo=""  cfgLilo=""
75    cfgExtlinux=""
76    cfguBoot=""
77  runLilo=""  runLilo=""
78  grubConfig=""  grubConfig=""
79    grub2Config=""
80    grub2EfiConfig=""
81    extlinuxConfig=""
82    ubootScript="/boot/boot.scr"
83    
84  ARCH=$(uname -m)  ARCH=$(uname -m)
85    
# Line 57  then Line 92  then
92  elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]  elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
93  then  then
94   liloConfig=/etc/yaboot.conf   liloConfig=/etc/yaboot.conf
95     grub2Config=/boot/grub/grub.cfg
96   bootPrefix=/boot   bootPrefix=/boot
97   lilo=/sbin/ybin   lilo=/sbin/ybin
98   liloFlag=yaboot   liloFlag=yaboot
# Line 77  then Line 113  then
113   lilo=/sbin/zipl   lilo=/sbin/zipl
114   runLilo="yes"   runLilo="yes"
115   isx86=""   isx86=""
116    elif [[ ${ARCH} =~ armv[5|7].*l ]]
117    then
118     liloConfig=""
119     bootPrefix=/boot
120     extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
121     ubootDir=${UBOOT_DIR:-"/boot"}
122     ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
123     ubootKList=${UBOOT_KLIST:-"klist.txt"}
124     ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
125     ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
126     ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
127     ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
128     mounted=""
129     liloFlag=""
130     isx86=""
131  else  else
132   # this leaves i?86 and x86_64   # this leaves i?86 and x86_64
133   liloConfig=/etc/lilo.conf   liloConfig=/etc/lilo.conf
134   grubConfig=/boot/grub/grub.conf   grubConfig=/boot/grub/grub.conf
135     grub2Config=/boot/grub/grub.cfg
136     grub2EfiConfig=/boot/grub/grub-efi.cfg
137     extlinuxConfig=/boot/extlinux/extlinux.conf
138   bootPrefix=/boot   bootPrefix=/boot
139   liloFlag=lilo   liloFlag=lilo
140   isx86="yes"   isx86="yes"
# Line 89  fi Line 143  fi
143  mode=""  mode=""
144  version=""  version=""
145  initrd=""  initrd=""
146    dracut=""
147    dracuthostonly=""
148  initrdfile=""  initrdfile=""
149    devtreefile=""
150  moddep=""  moddep=""
151  verbose=""  verbose=""
152  makedefault=""  makedefault=""
153  package=""  package=""
154  mbkernel=""  mbkernel="${HYPERVISOR}"
155  mbargs=""  mbargs="${HYPERVISOR_ARGS}"
156    adddracutargs=""
157    addplymouthinitrd=""
158    DEBUGARG="systemd.debug"
159    
160  usage()  usage()
161  {  {
162   echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd]" >&2   echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
163   echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2   echo "       [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
164   echo "       [--kernel-args=<args>] [--remove-args=<args>]" >&2   echo "       [--kernel-args=<args>] [--remove-args=<args>]" >&2
165   echo "       [--banner=<banner>] [--multiboot=multiboot]" >&2   echo "       [--banner=<banner>] [--multiboot=multiboot]" >&2
166   echo "       [--mbargs=mbargs] [--make-default]" >&2   echo "       [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
167     echo "       [--add-plymouth-initrd]" >&2
168     echo "       [--host-only] [--devtree=<devicetree.dtb>]" >&2
169   echo "       <--install | --remove | --update> <kernel-version>" >&2   echo "       <--install | --remove | --update> <kernel-version>" >&2
170   echo "       (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2   echo "       (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
171   exit 1   exit 1
172  }  }
173    
174  run_grub2()  rungrubby()
175    {
176     if [[ $1 == --debug ]]
177     then
178     [[ ${MAKEDEBUG} != yes ]] && return 0
179     [[ -n ${verbose} ]] && echo "- First, making a debug entry."
180     declare -x debugtitle=" with debugging"
181     declare -x debugargs="${DEBUGARG}"
182     shift
183     else
184     [[ -n ${verbose} ] && echo "- Making a normal entry."
185     fi
186     $(eval $grubby $@)
187     export -n debugargs
188     export -n debugtitle
189     unset debugargs
190     unset debugtitle
191    }
192    
193    set_title()
194  {  {
195   if [ -d /boot/grub2 -a -x /sbin/grub2-mkconfig ]   if [[ -n ${banner} ]]
196   then   then
197   cp /boot/grub2/grub.cfg /boot/grub2/grub.cfg.old   if [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
198   /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg   then
199     title=$(echo ${banner} | sed 's/ /_/g')
200     else
201     title="${banner} [ ${version} ]"
202     fi
203     elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
204     then
205     title=$(echo ${version} | sed 's/ /_/g')
206     elif [ -f /etc/os-release ]
207     then
208     title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
209     elif [ -f /etc/mageversion ]
210     then
211     title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
212     else
213     title="Magellan Linux [ ${version} ]"
214   fi   fi
215  }  }
216    
217  install()  install()
218  {  {
219   # XXX kernel should be able to be specified also (or work right on ia64)   # XXX kernel should be able to be specified also (or work right on ia64)
220   if [ ! -f ${bootPrefix}/${kernelName}-${version} ]   if [ ! -f ${kernelImage} ]
221   then   then
222   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
223   return   return
# Line 132  install() Line 228  install()
228   then   then
229   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
230   INITRD="--initrd ${initrdfile}"   INITRD="--initrd ${initrdfile}"
231    
232     if [[ -n ${addplymouthinitrd} ]]
233     then
234     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
235     fi
236     fi
237    
238     DEVTREE=""
239     if [[ x${devtreefile} != x ]] && [ -f "${devtreefile}" ]
240     then
241     [[ -n ${verbose} ]] && echo "found ${devtreefile} and using it with grubby"
242     DEVTREE="--devtree ${devtreefile}"
243   fi   fi
244    
245   # FIXME: is this a good heuristic to find out if we're on iSeries?   # FIXME: is this a good heuristic to find out if we're on iSeries?
# Line 141  install() Line 249  install()
249   if [[ -z ${initrdfile} ]]   if [[ -z ${initrdfile} ]]
250   then   then
251   [[ -n ${verbose} ]] && echo "No initrd, just adding system map"   [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
252   /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${bootPrefix}/${kernelName}-${version} ${bootPrefix}/vmlinitrd-${version}   /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
253   else   else
254   /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${bootPrefix}/${kernelName}-${version} ${bootPrefix}/vmlinux.sm-${version}   /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
255   /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null   /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
256   rm ${bootPrefix}/vmlinux.sm-${version}   rm ${bootPrefix}/vmlinux.sm-${version}
257   fi   fi
258   return   return
259   fi   fi
260    
  # Run grub2's configuration update in parallel, if it is installed  
  run_grub2  
   
261   # get the root filesystem to use   # get the root filesystem to use
262   rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab)   rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab  2>/dev/null)
263     if [[ -z $rootdevice ]]
264     then
265     rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
266     fi
267    
268   if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]   if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
269   then   then
# Line 162  install() Line 271  install()
271   cfgLilo=""   cfgLilo=""
272   fi   fi
273    
274     set_title
275    
276   if [[ -n ${cfgGrub} ]]   if [[ -n ${cfgGrub} ]]
277   then   then
278   [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"   [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
279    
280   if [[ -n ${banner} ]]   ARGS="--grub -c ${grubConfig} --add-kernel=${kernelImage} ${INITRD} \
281   then   ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
282   title="${banner} (${version})"   ${mbargs:+--mbargs=\"${mbargs}\"} \
283   elif [ -f /etc/mageversion ]   --title=\"${title}\${debugtitle}\" --copy-default \
284   then   --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
285   title="Magellan Linux $(< /etc/mageversion) (${version})"   --remove-kernel=\"TITLE=${title}\${debugtitle}\""
286   else   rungrubby --debug ${ARGS}
287   title="Magellan Linux (${version})"   rungrubby ${ARGS} ${makedefault}
  fi  
  ${grubby} --add-kernel=${bootPrefix}/${kernelName}-${version} \  
  ${INITRD} --copy-default ${makedefault} --title "${title}" \  
  ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \  
  --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"  
288   else   else
289   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
290     fi
291     if [[ -n ${cfgGrub2} ]]
292     then
293     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
294    
295     ARGS="--grub2 -c ${grub2Config} --add-kernel=${kernelImage} ${INITRD} \
296     --copy-default --title \"${title}\${debugtitle}\" \
297     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
298     ${mbargs:+--mbargs=\"${mbargs}\"} \
299     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
300     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
301     rungrubby --debug ${ARGS}
302     rungrubby ${ARGS} ${makedefault}
303     else
304     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
305     fi
306     if [[ -n ${cfgGrub2Efi} ]]
307     then
308     [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
309    
310     ARGS="--grub2 -c ${grub2EfiConfig} --efi \
311     --add-kernel=${kernelImage} ${DEVTREE} ${INITRD} \
312     --copy-default --title \"${title}\${debugtitle}\" \
313     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
314     ${mbargs:+--mbargs=\"${mbargs}\"} \
315     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
316     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
317     rungrubby --debug ${ARGS}
318     rungrubby ${ARGS} ${makedefault}
319     else
320     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
321   fi   fi
322    
323   if [[ -n ${cfgLilo} ]]   if [[ -n ${cfgLilo} ]]
324   then   then
325   [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"   [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
326    
327   ${grubby} --add-kernel=${bootPrefix}/${kernelName}-${version} ${INITRD} \   ARGS="--${liloFlag} --add-kernel=${kernelImage} ${INITRD} \
328   --copy-default ${makedefault} --title ${version} \   --copy-default --title \"${title}\${debugtitle}\" \
329   ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \   ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
330   --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \   ${mbargs:+--mbargs=\"${mbargs}\"} \
331   --${liloFlag}   --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
332     --remove-kernel=\"TITLE=${version}\""
333     rungrubby --debug ${ARGS}
334     rungrubby ${ARGS} ${makedefault}
335    
336   if [[ -n ${runLilo} ]]   if [[ -n ${runLilo} ]]
337   then   then
# Line 206  install() Line 346  install()
346   else   else
347   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
348   fi   fi
349    
350     if [[ -n ${cfgExtlinux} ]]
351     then
352     [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
353    
354     ARGS="--extlinux -c ${extlinuxConfig} --add-kernel=${kernelImage} \
355     ${DEVTREE} ${INITRD} --copy-default --title \"${title}\${debugtitle}\" \
356     ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
357     ${mbargs:+--mbargs=\"${mbargs}\"} \
358     --args=\"root=${rootdevice} ${kernargs} \${debugargs}\" \
359     --remove-kernel=\"TITLE=${title}\${debugtitle}\""
360     rungrubby --debug ${ARGS}
361     rungrubby ${ARGS} ${makedefault}
362     else
363     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
364     fi
365  }  }
366    
367  remove()  remove()
# Line 214  remove() Line 370  remove()
370   if [ -d /proc/iSeries ]   if [ -d /proc/iSeries ]
371   then   then
372   [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"   [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
373   rm -f ${bootPrefix}/${kernelName}-${version}.img 2>/dev/null   rm -f ${kernelImage}.img 2>/dev/null
374   return   return
375   fi   fi
376    
  # Run grub2's configuration update in parallel, if it is installed  
  run_grub2  
   
377   if [[ -n ${cfgGrub} ]]   if [[ -n ${cfgGrub} ]]
378   then   then
379   [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"   [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
380   ${grubby} --remove-kernel=${bootPrefix}/${kernelName}-${version}   ${grubby} --grub -c ${grubConfig} \
381     --remove-kernel=${kernelImage}
382   else   else
383   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
384     fi
385     if [[ -n ${cfgGrub2} ]]
386     then
387     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
388     ${grubby} --grub2 -c ${grub2Config} \
389     --remove-kernel=${kernelImage}
390     else
391     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
392     fi
393     if [[ -n ${cfgGrub2Efi} ]]
394     then
395     [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
396     ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
397     --remove-kernel=${kernelImage}
398     else
399     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
400   fi   fi
401    
402   if [[ -n ${cfgLilo} ]]   if [[ -n ${cfgLilo} ]]
403   then   then
404   [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"   [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
405   ${grubby} --remove-kernel=${bootPrefix}/${kernelName}-${version} --${liloFlag}   ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
406    
407   if [[ -n ${runLilo} ]]   if [[ -n ${runLilo} ]]
408   then   then
# Line 247  remove() Line 417  remove()
417   else   else
418   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
419   fi   fi
420    
421     if [[ -n ${cfguBoot} ]]
422     then
423     [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
424    
425     if [ -f ${ubootDir}/${ubootKList} ]
426     then
427     tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
428     curversion=$(tail -n1 ${ubootDir}/${ubootKList})
429     sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
430     newversion=$(tail -n1 ${tmpKList})
431     if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
432     then
433     if [[ ${curversion} != ${newversion} ]]
434     then
435     cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
436     if [ $? -ne 0 ]
437     then
438     [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
439     fi
440     cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
441     if [ $? -ne 0 ]
442     then
443     [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
444     fi
445     fi
446    
447     [[ -n ${verbose} ]] && echo "removing uImage-${version}"
448     if [ -f ${ubootDir}/uImage-${version} ]
449     then
450     rm -f ${ubootDir}/uImage-${version}
451     else
452     [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
453     fi
454    
455     [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
456     if [ -f ${ubootDir}/uInitrd-${version} ]
457     then
458     rm -f ${ubootDir}/uInitrd-${version}
459     else
460     [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
461     fi
462    
463     mv ${tmpKList} ${ubootDir}/${ubootKList}
464     [ -x /sbin/a-b-c ] && /sbin/a-b-c
465     else
466     [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
467     [ -f ${tmpKList} ] && rm -f ${tmpKList}
468     fi
469     else
470     [[ -n ${verbose} ]] && echo "No previous kernel version.  U-Boot images not removed!"
471     fi
472     else
473     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
474     fi
475    
476     if [[ -n ${cfgExtlinux} ]]
477     then
478     [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
479     ${grubby} --extlinux -c ${extlinuxConfig} \
480     --remove-kernel=${kernelImage}
481     else
482     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
483     fi
484  }  }
485    
486  update()  update()
487  {  {
488   if [ ! -f ${bootPrefix}/${kernelName}-${version} ]   if [ ! -f ${kernelImage} ]
489   then   then
490   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
491   return   return
492   fi   fi
493    
494     set_title
495    
496   INITRD=""   INITRD=""
497   if [ -f ${initrdfile} ]   if [ -f ${initrdfile} ]
498   then   then
499   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"   [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
500   INITRD="--initrd ${initrdfile}"   INITRD="--initrd ${initrdfile}"
501    
502     if [[ -n ${addplymouthinitrd} ]]
503     then
504     INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
505     fi
506   fi   fi
507    
508   # Run grub2's configuration update in parallel, if it is installed   DEVTREE=""
509   run_grub2   if [[ x${devtreefile} != x ]] && [ -f ${devtreefile} ]
510     then
511     [[ -n ${verbose} ]] && echo "found ${devtreefile} and using it with grubby"
512     DEVTREE="--devtree ${devtreefile}"
513     fi
514    
515   if [[ -n ${cfgGrub} ]]   if [[ -n ${cfgGrub} ]]
516   then   then
517   [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"   [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
518   ${grubby} --update-kernel=${bootPrefix}/${kernelName}-${version} \   ARGS="--grub -c ${grubConfig} --update-kernel=${kernelImage} ${INITRD} \
519   ${INITRD} \   ${kernargs:+--args=\"${kernargs}\"} \
520   ${kernargs:+--args="${kernargs}"} \   ${removeargs:+--remove-args=\"${removeargs}\"} \
521   ${removeargs:+--remove-args="${removeargs}"}   ${mbkernel:+--add-multiboot=\"${mbkernel}\"} \
522     --title=\"${title}\${debugtitle}\""
523     rungrubby --debug ${ARGS}
524     rungrubby ${ARGS}
525   else   else
526   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
527   fi   fi
528    
529     if [[ -n ${cfgGrub2} ]]
530     then
531     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
532     ARGS="--grub2 -c ${grub2Config} --update-kernel=${kernelImage} ${INITRD} \
533     ${kernargs:+--args=\"${kernargs}\"} \
534     ${removeargs:+--remove-args=\"${removeargs}\"} \
535     --title=\"${title}\${debugtitle}\""
536     rungrubby --debug ${ARGS}
537     rungrubby ${ARGS}
538     else
539     [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
540     fi
541    
542     if [[ -n ${cfgGrub2Efi} ]]
543     then
544     [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
545     ARGS="--grub2 -c ${grub2EfiConfig} --efi --update-kernel=${kernelImage} \
546     ${INITRD} ${kernargs:+--args=\"${kernargs}\"} \
547     ${removeargs:+--remove-args=\"${removeargs}\"} \
548     --title=\"${title}\${debugtitle}\""
549     rungrubby --debug ${ARGS}
550     rungrubby ${ARGS}
551     else
552     [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
553     fi
554    
555   if [[ -n ${cfgLilo} ]]   if [[ -n ${cfgLilo} ]]
556   then   then
557   [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"   [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
558   ${grubby} --update-kernel=${bootPrefix}/${kernelName}-${version} \   ARGS="--${liloFlag} --update-kernel=${kernelImage} ${INITRD} \
559   ${INITRD} \   ${kernargs:+--args=\"${kernargs}\"} \
560   ${kernargs:+--args="${kernargs}"} \   ${removeargs:+--remove-args=\"${removeargs}\"} \
561   ${removeargs:+--remove-args="${removeargs}"} \   --title=\"${title}\${debugtitle}\""
562   --${liloFlag}   rungrubby --debug ${ARGS}
563     rungrubby ${ARGS}
564    
565   if [[ -n ${runLilo} ]]   if [[ -n ${runLilo} ]]
566   then   then
# Line 300  update() Line 575  update()
575   else   else
576   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"   [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
577   fi   fi
578    
579     if [[ -n ${cfguBoot} ]]
580     then
581     [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
582    
583     [[ -n ${verbose} ]] && echo "creating uImage-${version}"
584     mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
585     -e ${ubootAddress} -n ${version} \
586     -d ${kernelImage} ${ubootDir}/uImage-${version}
587    
588     [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
589     mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
590     -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
591    
592     if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
593     then
594     cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
595     if [ $? -ne 0 ]
596     then
597     [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
598     fi
599     cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
600     if [ $? -ne 0 ]
601     then
602     [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
603     fi
604     echo ${version} >> ${ubootDir}/${ubootKList}
605     [ -x /sbin/a-b-c ] && /sbin/a-b-c
606     else
607     [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
608     fi
609     else
610     [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
611     fi
612    
613     if [[ -n ${cfgExtlinux} ]]
614     then
615     [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
616     ARGS="--extlinux -c ${extlinuxConfig} --update-kernel=${kernelImage} \
617     ${DEVTREE} ${INITRD} ${kernargs:+--args=\"${kernargs}\"} \
618     ${removeargs:+--remove-args=\"${removeargs}\"} \
619     --title=\"${title}\${debugtitle}\""
620     rungrubby --debug ${ARGS}
621     rungrubby ${ARGS}
622     else
623     [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
624     fi
625  }  }
626    
627  mkinitrd()  makeinitrd()
628  {  {
629     if [[ -n ${dracut} ]]
630     then
631     tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
632     else
633     tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
634     fi
635   [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"   [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
636   /sbin/mkinitrd --allow-missing -f ${initrdfile} ${version}   ${tool}
637   rc=$?   rc=$?
638   if [ ${rc} != 0 ]   if [ ${rc} != 0 ]
639   then   then
# Line 329  doDepmod() Line 657  doDepmod()
657  doRmmoddep()  doRmmoddep()
658  {  {
659   [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"   [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
660   [ -d /lib/modules/${version} ] && rm -f /lib/modules/${version}/modules.*   if [ -d /lib/modules/${version} ]
661     then
662     rm -f /lib/modules/${version}/modules.*.bin \
663     /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
664     fi
665  }  }
666    
667    # kernel image for 2.4 is kernel
668    if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
669    then
670     if [[ ${kernelmajor} = 2.4 ]]
671     then
672     kernelName=kernel
673     fi
674    fi
675    
676  while [ $# -gt 0 ]  while [ $# -gt 0 ]
677  do  do
# Line 344  do Line 684  do
684   initrd="remove"   initrd="remove"
685   ;;   ;;
686    
687     --devtree*)
688     if [[ $1 == --devtree\=* ]]
689     then
690     devtreefile="${1#--devtreefile=}"
691     else
692     devtreefile="$2"
693     shift
694     fi
695     ;;
696    
697     --dracut)
698     dracut=--dracut
699     ;;
700    
701     --host-only)
702     dracuthostonly=-H
703     ;;
704    
705   --initrdfile*)   --initrdfile*)
706   if echo $1 | grep '=' >/dev/null   if [[ $1 == --initrdfile\=* ]]
707   then   then
708   initrdfile=$(echo $1 | sed 's/^--initrdfile=//')   initrdfile=${1#--initrdfile=}
709   else   else
710   initrdfile=$2   initrdfile=$2
711   shift   shift
# Line 355  do Line 713  do
713   ;;   ;;
714    
715   --kernel-args*)   --kernel-args*)
716   if echo $1 | grep '=' >/dev/null   if [[ $1 == --kernel-args\=* ]]
717   then   then
718   kernargs=$(echo $1 | sed 's/^--kernel-args=//')   kernargs=${1#--kernel-args=}
719   else   else
720   kernargs=$2   kernargs=$2
721   shift   shift
# Line 365  do Line 723  do
723   ;;   ;;
724    
725   --remove-args*)   --remove-args*)
726   if echo $1 | grep '=' >/dev/null   if [[ $1 == --remove-args\=* ]]
727   then   then
728   removeargs=$(echo $1 | sed 's/^--remove-args=//')   removeargs=${1#--remove-args=}
729   else   else
730   removeargs=$2   removeargs=$2
731   shift   shift
# Line 375  do Line 733  do
733   ;;   ;;
734    
735   --banner*)   --banner*)
736   if echo $1 | grep '=' >/dev/null   if [[ $1 == --banner\=* ]]
737   then   then
738   banner=$(echo $1 | sed 's/^--banner=//')   banner=${1#--banner=}
739   else   else
740   banner=$2   banner=$2
741   shift   shift
# Line 385  do Line 743  do
743   ;;   ;;
744    
745   --multiboot*)   --multiboot*)
746   if echo $1 |grep '=' >/dev/null   if [[ $1 == --multiboot\=* ]]
747   then   then
748   mbkernel=$(echo $1 | sed 's/^--multiboot=//')   mbkernel=${1#--multiboot=}
749   else   else
750   # can't really support having an optional second arg here   # can't really support having an optional second arg here
751   # sorry!   # sorry!
# Line 396  do Line 754  do
754   ;;   ;;
755    
756   --mbargs*)   --mbargs*)
757   if echo $1 |grep '=' >/dev/null   if [[ $1 == --mbargs\=* ]]
758   then   then
759   mbargs=$(echo $1 | sed 's/^--mbargs=//')   mbargs=${1#--mbargs=}
760   else   else
761   mbargs="$2"   mbargs="$2"
762   shift   shift
# Line 417  do Line 775  do
775   makedefault="--make-default"   makedefault="--make-default"
776   ;;   ;;
777    
778   --package)   --package*)
779   if echo $1 | grep '=' >/dev/null   if [[ $1 == --package\=* ]]
780   then   then
781   package=$(echo $1 | sed 's/^--package=//')   package=${1#--package=}
782   else   else
783   package=$2   package=$2
784   shift   shift
785   fi   fi
786   ;;   ;;
787    
788     --add-dracut-args)
789     adddracutargs=--add-dracut-args
790     ;;
791    
792     --add-plymouth-initrd)
793     addplymouthinitrd=--add-plymouth-initrd
794     ;;
795    
796     --kernel-image*)
797     if [[ $1 == --kernel-image\=* ]]
798     then
799     kernelImage=${1#--kernel-image=}
800     else
801     kernelImage="$2"
802     shift
803     fi
804     if ! [[ -f ${kernelImage} ]]
805     then
806     echo "Can't find kernel image '${kernelImage}'" >&2
807     usage
808     exit 1
809     fi
810     ;;
811    
812     --kernel-name*)
813     if [[ $1 == --kernel-name\=* ]]
814     then
815     kernelName=${1#--kernel-name=}
816     else
817     kernelName="$2"
818     shift
819     fi
820     ;;
821    
822   -v)   -v)
823   verbose=-v   verbose=-v
824   ;;   ;;
# Line 465  fi Line 857  fi
857    
858  kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)  kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
859    
860  # kernel image for 2.4 is kernel  [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
 if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]  
 then  
  if [[ ${kernelmajor} = 2.4 ]]  
  then  
  kernelName=kernel  
  fi  
 fi  
861    
862  # set the initrd file based on arch; ia64 is the only currently known oddball  # set the initrd file based on arch; ia64 is the only currently known oddball
863  if [[ -z ${initrdfile} ]]  if [[ -z ${initrdfile} ]]
864  then  then
865   INITRD_NAME_PREFIX="initrd"   INITRD_NAME_PREFIX="initrd"
866     if [[ -n ${dracut} ]]
867     then
868     INITRD_NAME_PREFIX="initramfs"
869     fi
870    
871   if [[ $(uname -m) = ia64 ]]   if [[ $(uname -m) = ia64 ]]
872   then   then
# Line 488  then Line 877  then
877  fi  fi
878  [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"  [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
879    
880    if [[ ${ARCH} =~ armv[5|7].*l ]]
881    then
882     if [ -d ${bootPrefix}/dtb-${version}/ ]
883     then
884     devtreedir="${bootPrefix}/dtb-${version}/"
885     if [[ -n ${dtbfile} ]] && [ -f ${devtreedir}/${dtbfile} ]
886     then
887     devtreefile="${devtreedir}/${dtbfile}"
888     fi
889     fi
890    fi
891    [[ -n ${verbose} ]] && echo "devtreedir is ${devtreedir}"
892    
893    # add dracut i18n, keyboard and plymouth kernel args if requested
894    if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
895    then
896     if [ -r /etc/vconsole.conf ]
897     then
898     . /etc/vconsole.conf
899    
900     for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
901     do
902     val=$(eval echo \$$i)
903     [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
904     done
905     else
906     if [ -r /etc/conf.d/consolefont ]
907     then
908     . /etc/conf.d/consolefont
909    
910     if [[ -n ${CONSOLEFONT} ]]
911     then
912     kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
913     fi
914     fi
915    
916     if  [ -r /etc/conf.d/keymap ]
917     then
918     . /etc/conf.d/keymap
919    
920     if [[ -n ${KEYMAP} ]]
921     then
922     kernargs="${kernargs} KEYTABLE=${KEYMAP}"
923     fi
924     fi
925     fi
926    
927     if [ -r /etc/locale.conf ]
928     then
929     . /etc/locale.conf
930    
931     if [[ -n ${LANG} ]]
932     then
933     kernargs="${kernargs} LANG=${LANG}"
934     fi
935     fi
936    fi
937    
938  # set this as the default if we have the package and it matches  # set this as the default if we have the package and it matches
939  if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&  if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] && [[ -n ${DEFAULTKERNEL} ]]
  [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]  
940  then  then
941   makedefault="--make-default"   if [[ ${package} = ${DEFAULTKERNEL} ]] || [[ ${package}-core = ${DEFAULTKERNEL} ]]
942   [[ -n ${verbose} ]] && echo "making it the default based on config"   then
943     makedefault="--make-default"
944     [[ -n ${verbose} ]] && echo "making it the default based on config"
945     fi
946  fi  fi
947    
948  if [[ ${moddep} = make ]]  if [[ ${moddep} = make ]]
# Line 506  fi Line 955  fi
955    
956  if [[ ${initrd} = make ]]  if [[ ${initrd} = make ]]
957  then  then
958   mkinitrd   makeinitrd
959  elif [[ ${initrd} = remove ]]  elif [[ ${initrd} = remove ]]
960  then  then
961   rminitrd   rminitrd
# Line 519  then Line 968  then
968  fi  fi
969    
970  [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1  [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
971    [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
972    [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
973  [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1  [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
974    [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
975    
976    # if we have a U-Boot directory, but no boot script, check if the directory
977    # is mounted.  If not, mount it, and then check if a boot script exists.
978    if [[ -n ${ubootDir} ]]
979    then
980     if [ -f ${ubootScript} ]
981     then
982     cfguBoot=1
983     else
984     mountEntry=$(mount | grep ${ubootDir})
985     if [[ -z ${mountEntry} ]]
986     then
987     mount ${ubootDevice} ${ubootDir}
988     mounted=1
989     fi
990     [ -f ${ubootScript} ] && cfguBoot=1
991     fi
992    fi
993    
994    # if we're using U-Boot, check if the default load address should change
995    if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
996    then
997     [[ ${version}  =~ .([^.]*)$ ]]
998     platform=${BASH_REMATCH[1]}
999     # A few platforms use an alternate kernel load address
1000     if [[ ${platform} = omap ]]
1001     then
1002     ubootAddress=0x80008000
1003     elif [[ ${platform} = imx ]]
1004     then
1005     ubootAddress=0x90008000
1006     fi
1007    fi
1008    
1009  # if we have a lilo config on an x86 box, see if the default boot loader  # if we have a lilo config on an x86 box, see if the default boot loader
1010  # is lilo to determine if it should be run  # is lilo to determine if it should be run
# Line 539  then Line 1024  then
1024   update   update
1025  fi  fi
1026    
1027    # if we mounted the U-Boot directory, unmount it.
1028    [[ -n ${mounted} ]] && umount ${ubootDir}
1029    
1030  exit 0  exit 0

Legend:
Removed from v.1332  
changed lines
  Added in v.2971